 /*
  * Khoros: $Id: helppage.h,v 1.2 1991/10/02 00:01:11 khoros Exp $
  */

 /*
  * $Log: helppage.h,v $
 * Revision 1.2  1991/10/02  00:01:11  khoros
 * HellPatch2
 *
  */

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as to the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including, for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: helppage.h
 >>>>            Author: Tom Sauer and Charlie Gage
 >>>> Date Last Updated: Wed Sep 25 22:10:47 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _helppage_h_
#define _helppage_h_

#include "vinclude.h"


/* -include_includes */
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program;	/* a pointer to the program name argv[0] */
int	ac;

/****************************************************************
*
*                    helppage Argument Structure
*
****************************************************************/

typedef struct _helppage  {

/*----- these are a Required mutually exclusive group ----*/
/*
 *  input Man (1) file (Required infile)
 */
char	*i_file;	/* input Man (1) file FILENAME */
int	 i_flag;	/* input Man (1) file FLAG */

/*
 *  Format All Man (1) pages (Required logical)
 */
int	 all_logic;	/* Format All Man (1) pages LOGIC */
int	 all_flag;  	/* Format All Man (1) pages FLAG */

/*-------------------------------------------*/

/*
 *  Toolbox name (Optional string)
 */
char	*toolbox_string;	/* Toolbox name STRING */
int	 toolbox_flag;   	/* Toolbox name FLAG */

}  helppage_struct;

helppage_struct *helppage;

/* -include_additions */
#define BUFSIZE 500*4
/* -include_additions_end */

/* -include_macros */
/* -include_macros_end */

#endif
