 /*
  * Khoros: $Id: vgconst.h,v 1.2 1991/12/18 09:37:18 dkhoros Exp $
  */

 /*
  * $Log: vgconst.h,v $
 * Revision 1.2  1991/12/18  09:37:18  dkhoros
 * HellPatch3
 *
  */

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as to the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including, for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: vgconst.h
 >>>>            Author: Marcelo Teran, Ramiro Jordan, Tom Sauer
 >>>> Date Last Updated: Mon Dec  9 23:22:59 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _vgconst_h_
#define _vgconst_h_

#include "vinclude.h"


/* -include_includes */
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program;	/* a pointer to the program name argv[0] */
int	ac;

/****************************************************************
*
*                    vgconst Argument Structure
*
****************************************************************/

typedef struct _vgconst  {

/*
 *  resulting image (Required outfile)
 */
char	*o_file;	/* resulting image FILENAME */
int	 o_flag;	/* resulting image FLAG */

/*
 *  trigger input (Optional infile)
 */
char	*trigger_file;	/* trigger input FILENAME */
int	 trigger_flag;	/* trigger input FLAG */

/*
 *  Number of rows (Optional integer)
 */
int	 r_int; 	/* Number of rows INT */
int	 r_flag;	/* Number of rows FLAG */

/*
 *  Number of columns (Optional integer)
 */
int	 c_int; 	/* Number of columns INT */
int	 c_flag;	/* Number of columns FLAG */

/*
 *  Number of data bands (Optional integer)
 */
int	 b_int; 	/* Number of data bands INT */
int	 b_flag;	/* Number of data bands FLAG */

/*
 *  image constant level (Optional float)
 */
float	 l_float;	/* image constant level FLOAT */
int	 l_flag;   	/* image constant level FLAG */

/*
 *  image imaginary constant level (Optional float)
 */
float	 m_float;	/* image imaginary constant level FLOAT */
int	 m_flag;   	/* image imaginary constant level FLAG */

/*
 * lets user choose data type of image (Optional string toggle - )
 */
char	*t_toggle;		/* lets user choose data type of image STRING TOGGLE */
int	 t_flag;		/* lets user choose data type of image FLAG */

}  vgconst_struct;

vgconst_struct *vgconst;

/* -include_additions */
/* -include_additions_end */

/* -include_macros */
/* -include_macros_end */

#endif
